> For the complete documentation index, see [llms.txt](https://docs.robpod.cloud/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.robpod.cloud/appendix/robot-specific-functions/universal-robots/ursim.md).

# URSim

Robpod Studio can be used also to connect to **URSim** simulation environment instead of the real robot.

{% tabs %}
{% tab title="Polyscope 5 and 3" %}
URSim for **Polyscope 5** and erlier versions are provided as a **virtual machine** image.

No particular configuration is needed to connect Robpod Studio to the virtual machine simulator.

Just start the virtual machine, check the virtual machine ip address, and then proceed in the same way as with real robot.
{% endtab %}

{% tab title="Polyscope X" %}
URSim for **Polyscope X** is provided as a **docker container** image.

Some configuration is needed before connecting Robpod Studio to the URSim simulation inside the container.

**Port Mapping**

Ports 30001, 30002, 30011, 8879 must be added your PolyscopeX simulator container.

To run a container with port mapping already configured execute this command:

{% code overflow="wrap" %}

```ada
docker run --hostname=1dfef917de85 --env=DOCKER_TLS_CERTDIR=/certs --env=TARGETARCH=amd64 --env=IMAGE_PSX_BOOTSTRAPPER_VERSION=0.6.8 --env=JAVA_BACKEND_ARGS= --env=CONTROLLER_IMAGE=docker.urrd.dk/tool/controller-artifact:90.1.13 --env=ACTUAL_PSX_SERVICES_VERSION=23.2.9 --env=ACTUAL_PSX_BOOTSTRAPPER_VERSION=0.6.8 --env=ACTUAL_SW_LICENSING_PSX_VERSION=0.8.2 --env=ROBOT_TYPE_CONTROLLER=UR5 --env=HOST_ARCH=x64 --env=DEVMODE=true --env=PATH=/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin --env=DOCKER_COMPOSE_VERSION=2.40.3 --env=DIND_COMMIT=8d9e3502aba39127e4d12196dae16d306f76993d --env=ROBOT_TYPE=UR5 --env=ROS2_NAMESPACE=UR8888 --env=DOCKER_VERSION=29.1.1 --env=URSERVICE_IMAGE=docker.urrd.dk/urservice:19.10.31 --env=DOCKER_BUILDX_VERSION=0.30.1 --env=IMAGE_PSX_SERVICES_VERSION=23.2.9 --env=IMAGE_SW_LICENSING_PSX_VERSION=0.8.2 --env=ROS2_DOMAIN_ID=1 --volume=ursim-polyscopex-applications:/ur/bin/backend/applications:rw --volume=ursim-polyscopex-safety-volume:/ur/etc/backend/safety:rw --volume=ursim-polyscopex-urcaps:/var/urcaps:rw --volume=ursim-polyscopex-ur-snippets:/etc/nginx/ur-snippets:rw --volume=ursim-polyscopex-docker-volume:/var/lib/docker:rw --volume=/var/lib/docker --network=bridge --privileged --workdir=/root -p 29999:29999 -p 30001:30001 -p 30002:30002 -p 30011:30011 -p 80:80 -p 8879:8879 --restart=no --label=''com.docker.compose.config-hash=3e1ed2181000a0f759903e488fd9a221760e166d09e2953e3ec4e09e668b97f0'' --label=''com.docker.compose.container-number=1'' --label=''com.docker.compose.depends_on='' --label=''com.docker.compose.image=sha256:d681b22c1aaf6cec1dead8b52e5fd0876ac94ac2ab88f567a7cffb3099d556ff'' --label=''com.docker.compose.oneoff=False'' --label=''com.docker.compose.project=ursim-polyscopex'' --label=''com.docker.compose.project.config_files=/ursim-polyscopex-0.18.81/artifacts/runtime/docker-compose.yml'' --label=''com.docker.compose.project.environment_file=/ursim-polyscopex-0.18.81/artifacts/runtime/.env'' --label=''com.docker.compose.project.working_dir=/ursim-polyscopex-0.18.81/artifacts/runtime'' --label=''com.docker.compose.service=runtime'' --label=''com.docker.compose.version=5.1.1'' --label=''com.ur.web.bootstrapper=0.6.8'' --label=''com.ur.web.citadel-version=0.24.4'' --label=''com.ur.web.controller-version=90.1.13'' --label=''com.ur.web.foxglove-bridge-version=1.0.3'' --label=''com.ur.web.frontend-version=21.3.196'' --label=''com.ur.web.nginx-version=1.25.5'' --label=''com.ur.web.platform-version=1.2.511'' --label=''com.ur.web.polyscopex-services-version=23.2.9'' --label=''com.ur.web.sw-licensing-psx-version='' --label=''com.ur.web.urauth-version=1.10.1'' --label=''com.ur.web.urinterfaces-version=9.0.0'' --label=''com.ur.web.urservice-version=19.10.31'' --label=''desktop.docker.io/wsl-distro=Ubuntu'' --label=''org.opencontainers.image.version=21.3.196'' --label=''version=21.3.196'' --label='com.ur.web.bootstrapper=0.6.8' --label='com.ur.web.citadel-version=0.24.4' --label='com.ur.web.controller-version=90.1.13' --label='com.ur.web.foxglove-bridge-version=1.0.3' --label='com.ur.web.frontend-version=21.3.196' --label='com.ur.web.nginx-version=1.25.5' --label='com.ur.web.platform-version=1.2.511' --label='com.ur.web.polyscopex-services-version=23.2.9' --label='com.ur.web.sw-licensing-psx-version=' --label='com.ur.web.urauth-version=1.10.1' --label='com.ur.web.urinterfaces-version=9.0.0' --label='com.ur.web.urservice-version=19.10.31' --label='org.opencontainers.image.version=21.3.196' --label='version=21.3.196' --add-host host.docker.internal:host-gateway --runtime=runc -d universalrobots/ursim_polyscopex:0.18.81
```

{% endcode %}

{% endtab %}
{% endtabs %}


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.robpod.cloud/appendix/robot-specific-functions/universal-robots/ursim.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
